function calculerRes()
  
  Z = read('slump.data',-1,11);
  Z = Z (1:103,2:11);
  Z = normaliser(Z,0,1);
  
  // Construction du tableau des donnes X
  X = Z(1:103,1:7);
  
  // Construction du tableau des rsultats Y8,Y9,Y10
  Y8 =  Z(1:103,8);
  Y9 =  Z(1:103,9);
  Y10 = Z(1:103,10);
  
  // Calcul des solutions S8,S9,S10 et des rsidus resdidu8,resdidu9,resdidu10
  [S8,residu8] = approxMC(X,Y8);
  [S9,residu9] = approxMC(X,Y9);
  [S10,residu10] = approxMC(X,Y10);
  
  // On trace les trois rsidus
  xset("window",1);
  plot2d(1:103,residu8,style=[-5]);
  xset("window",2);
  plot2d(1:103,residu9,style=[-5]);
  xset("window",3);
  plot2d(1:103,residu10,style=[-5]);
  
  // Calcul des erreurs e8,e9,e10
  e8 = norm(residu8);
  printf("Norme du rsidu n8 : %f .\n",e8);
  e9 = norm(residu9);
  printf("Norme du rsidu n9 : %f .\n",e9);
  e10 = norm(residu10);
  printf("Norme du rsidu n10 : %f .\n",e10);
   
  // On essaie d'estimer Y8 en fonction de Y9 et Y10
  [SY8,residuY8] = approxMC([Y9,Y10],Y8);
  eY8 = norm(residuY8);
  printf("Norme du rsidu de Y8 fonction de Y9/Y10 : %f .\n",eY8);  
  
  // On essaie d'estimer Y9 en fonction de Y8 et Y10  
  [SY9,residuY9] = approxMC([Y8,Y10],Y9);
  eY9 = norm(residuY9);
  printf("Norme du rsidu de Y9 fonction de Y8/Y10 : %f .\n",eY9);  
  
  // On essaie d'estimer Y10 en fonction de Y8 et Y9    
  [SY10,residuY10] = approxMC([Y8,Y9],Y10);
  eY10 = norm(residuY10);
  printf("Norme du rsidu de Y10 fonction de Y8/Y9 : %f .\n",eY10);  
  
endfunction

function Z=normaliser(Z,A,B)
  
  for j = 1:10 
    max_j = max(Z(:,j));
    min_j = min(Z(:,j));
    for i = 1:103
      Z(i,j) = (Z(i,j)-min_j)*(B-A)/(max_j-min_j) + A;
    end
  end
endfunction
      
function [solution_1,residu_1]=approxMC(X,Y)
  
  // DVS de X
  [U,D,V]=svd(X);
  
  // Construction de la pseudoInverse X_inv
  X_inv = V*(inverse(D))*(U');
  
  // Construction de la solution
  solution_1 = X_inv*Y;
  // Calcul du rsidu
  residu_1 = Y - X*solution_1;
  
endfunction

function res=inverse(M)


  [ligne,colonne] = size(M);

  res = zeros(colonne,ligne);
  
  for i = 1:ligne
     for j = 1:colonne
          if M(i,j) ~= 0 then
            res(j,i) = 1/M(i,j);  
          end
     end
  end

endfunction

